#include <sys/types.h>
#include <sys/ioccom.h>

#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <libgen.h>

#define	INTR_BLOCKING_DOIT1	_IOW('x', 57, u_long)
#define	INTR_BLOCKING_DOIT2	_IOW('x', 58, u_long)

static const char *progname;

static void
usage(void)
{

	fprintf(stderr, "Usage: %s -t <1|2> [-i <iterations>]\n", progname);
	exit(1);
}

int
main(int argc, char *argv[])
{
	int ch, fd, error, testnum;
	u_long iocnum, iterations;

	progname = basename(argv[0]);

	testnum = -1;
	iterations = 0;

	while ((ch = getopt(argc, argv, "i:t:")) != -1) {
		switch (ch) {
		case 'i':
			iterations = strtoul(optarg, NULL, 0);
			break;
		case 't':
			testnum = (int)strtoul(optarg, NULL, 0);
			break;
		default:
			usage();
		}
	}

	if (testnum == 1) {
		iocnum = INTR_BLOCKING_DOIT1;
		if (iterations == 0)
			iterations = 2000000;
	} else if (testnum == 2) {
		iocnum = INTR_BLOCKING_DOIT2;
		if (iterations == 0)
			iterations = 2000000000;
	} else
		usage();

	fd = open("/dev/intr_blocking", O_RDWR, 0);
	if (fd < 0) {
		perror("open");
		exit(1);
	}

	error = ioctl(fd, iocnum, &iterations);
	if (error) {
		perror("ioctl");
		exit(1);
	}

	exit(0);
}
